// color.hpp

// author: Tiago Cavalcante Trindade
// version: 2.0.0
// email: tiagotrindade111@gmail
// access: https://www.clubedohardware.com.br/forums/topic/1396899-tutorial-como-colocar-cor-no-c/

#pragma once

#include <iostream>
#include <stdlib.h>

#ifndef DEFAULT
#define DEFAULT "[0m"
#endif

#define fBLACK             "[30m" /* letra preta */
#define fRED               "[31m" /* letra vermelha */
#define fGREEN             "[32m" /* letra verde */
#define fYELLOW            "[33m" /* letra amarela */
#define fBLUE              "[34m" /* letra azul */
#define fMAGENTA           "[35m" /* letra magenta */
#define fCYAN              "[36m" /* letra ciano */
#define fWHITE             "[37m" /* letra branca */
#define fBLACKs            "[90m" /* letra cinza */
#define fREDs              "[91m" /* letra vermelha clara */
#define fGREENs            "[92m" /* letra verde claro */
#define fYELLOWs           "[93m" /* letra amarela clara */
#define fBLUEs             "[94m" /* letra azul clara */
#define fMAGENTAs          "[95m" /* letra magenta clara */
#define fCYANs             "[96m" /* letra ciana clara */
#define fWHITEs            "[97m" /* letra branca */
#define bBLACK             "[40m" /* fundo preto */
#define bRED               "[41m" /* fundo vermelho */
#define bGREEN             "[42m" /* fundo verde */
#define bYELLOW            "[43m" /* fundo amarelo */
#define bBLUE              "[44m" /* fundo azul */
#define bMAGENTA           "[45m" /* fundo magenta */
#define bCYAN              "[46m" /* fundo ciano */
#define bWHITE             "[47m" /* fundo branco */
#define bBLACKs           "[100m" /* fundo cinza */
#define bREDs             "[101m" /* fundo vermelho claro */
#define bGREENs           "[102m" /* fundo verde claro */
#define bYELLOWs          "[103m" /* fundo amarelo claro */
#define bBLUEs            "[104m" /* fundo azul claro */
#define bMAGENTAs         "[105m" /* fundo magenta claro */
#define bCYANs            "[106m" /* fundo ciano claro */
#define bWHITEs           "[107m" /* fundo branco */
#define sRESET              "[0m" /* estilo de letra padro */
#define sBOLD               "[1m" /* texto claro (negrito) */
#define sDARK               "[2m" /* texto escuro */
#define sUNDERLINE          "[4m" /* sublinhado */
#define sINVERSE            "[7m" /* inverte a cor do fundo com a cor da letra */
#define rBOLDDARK          "[22m" /* remove o atributo de texto claro ou escuro */
#define rUNDERLINE         "[24m" /* remove o sublinhado */
#define rINVERSE           "[27m" /* remove a inverso de cores */
#define rAll       "[22m[24m[27m" /* remove todos os atributos (sBOLD, sDARK, sUNDERLINE e sINVERSE) */

std::string TEXT = "\0";

namespace style {
	enum wFOREGROUND : char {
		wfBLACK    = '0', /* letra preta */
		wfRED      = '4', /* letra vermelha */
		wfGREEN    = '2', /* letra verde */
		wfYELLOW   = '6', /* letra amarela */
		wfBLUE     = '1', /* letra azul */
		wfMAGENTA  = '5', /* letra magenta */
		wfCYAN     = '3', /* letra ciano */
		wfWHITE    = '7', /* letra branca */
		wfBLACKs   = '8', /* letra preta clara */
		wfREDs     = 'c', /* letra vermelha clara */
		wfGREENs   = 'a', /* letra verde clara */
		wfYELLOWs  = 'e', /* letra amarela clara */
		wfBLUEs    = '9', /* letra azul clara */
		wfMAGENTAs = 'd', /* letra magenta clara */
		wfCYANs    = 'b', /* letra ciana clara */
		wfWHITEs   = 'f', /* letra branca clara */
	};
	enum wBACKGROUND : char {
		wbBLACK    = '0', /* fundo preto */
		wbRED      = '4', /* fundo vermelho */
		wbGREEN    = '2', /* fundo verde */
		wbYELLOW   = '6', /* fundo amarelo */
		wbBLUE     = '1', /* fundo azul */
		wbMAGENTA  = '5', /* fundo magenta */
		wbCYAN     = '3', /* fundo ciano */
		wbWHITE    = '7', /* fundo branco */
		wbBLACKs   = '8', /* fundo preto claro */
		wbREDs     = 'c', /* fundo vermelho claro */
		wbGREENs   = 'a', /* fundo verde claro */
		wbYELLOWs  = 'e', /* fundo amarelo claro */
		wbBLUEs    = '9', /* fundo azul claro */
		wbMAGENTAs = 'd', /* fundo magenta claro */
		wbCYANs    = 'b', /* fundo ciano claro */
		wbWHITEs   = 'f', /* fundo branco claro */
	};
}

namespace color {
	/*muda o estilo (pode ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style) {
		system(style);
	}
	/*muda dois estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style1, const char* style2) {
		TEXT = (char)"echo " + (char)style1 + (char)style2 + (char)"\0";
		system(TEXT.c_str());
	}
	/*muda trs estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(const char* style1, const char* style2, const char* style3) {
		TEXT = (char)"echo " + (char)style1 + (char)style2 + (char)style3 +"\0";
		system(TEXT.c_str());
	}
	/*muda quatro estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(std::string style1, std::string style2, std::string style3, std::string style4) {
		TEXT = "echo " + style1 + style2 + style3 + style4;
		system(TEXT.c_str());
	}
	/*muda cinco estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void style(std::string style1, std::string style2, std::string style3, std::string style4, std::string style5) {
		TEXT = "echo " + style1 + style2 + style3 + style4 + style5;
		system(TEXT.c_str());
	}
	/*escreve um texto com a cor padro ou com o retorno de um gett() */
	inline void coutc(std::string text, std::string style) {
		TEXT = "echo " + std::string(DEFAULT) + style + text + std::string(DEFAULT);
		system(TEXT.c_str());
	}
	/*escreve um texto com um estilo (pode ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(std::string text) {
		TEXT = "echo " + std::string(DEFAULT) + text + std::string(DEFAULT);
		system(TEXT.c_str());
	}
	/*escreve um texto com dois estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(std::string text, std::string style1, std::string style2) {
		TEXT = "echo " + std::string(DEFAULT) + style1 + style2 + text + std::string(DEFAULT);
		system(TEXT.c_str());
	}
	/*escreve um texto com trs estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(std::string text, std::string style1, std::string style2, std::string style3) {
		TEXT = "echo " + std::string(DEFAULT) + style1 + style2 + style3 + text + std::string(DEFAULT);
		system(TEXT.c_str());
	}
	/*escreve um texto com quatro estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(std::string text, std::string style1, std::string style2, std::string style3, std::string style4) {
		TEXT = "echo " + std::string(DEFAULT) + style1 + style2 + style3 + style4 + text + std::string(DEFAULT);
		system(TEXT.c_str());
	}
	/*escreve um texto com cinco estilos (podem ser cor da letra, cor do fundo ou estilo,...)*/
	inline void coutc(std::string text, std::string style1, std::string style2, std::string style3, std::string style4, std::string style5) {
		TEXT = "echo " + std::string(DEFAULT) + style1 + style2 + style3 + style4 + style5 + text + std::string(DEFAULT);
		system(TEXT.c_str());
	}
	/*muda a cor da letra de todo o cmd*/
	inline void color(style::wFOREGROUND foreground) {
		system(std::string("color " + foreground).c_str());
	}
	/*muda a cor de todo o cmd; muda a cor da letra e do fundo*/
	inline void color(style::wFOREGROUND foreground, style::wBACKGROUND background) {
		system(std::string("color " + foreground + background).c_str());
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de um estilo, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de dois estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de trs estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3, const char* text4) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)text4 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de quatro estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3, const char* text4, const char* text5) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)text4 + (char)text5 + (char)DEFAULT;
	}
	/*como coutc, mas, retorna o texto de DEFAULT, de cinco estilos, do texto em si e do DEFAULT (novamente)*/
	inline char gett(const char* text1, const char* text2, const char* text3, const char* text4, const char* text5, const char* text6) {
		return (char)DEFAULT + (char)text1 + (char)text2 + (char)text3 + (char)text4 + (char)text5 + (char)text6 + (char)DEFAULT;
	}
	/*limpa a tela*/
	inline void clear() {
		system("cls");
	}
}